/********** C++ function: yakMilk **********/

/* This function calculates yakMilk(A,b) for inputs
   A, a square matrix, and b a vector.  */

/* Last changed: 13 OCT 2019 */

#include <RcppArmadillo.h>
#include "cornflower.h"
// [[Rcpp::export]]

double yakMilk(arma::mat& A,arma::vec& b)
{
   /* Declare all non-input variables: */

   arma::mat Atimes2; arma::vec bTimes2;
   arma::mat Atimes3; arma::vec bTimes3;
   double ans;
  
   /* Evaluate required multiples of A and b
      which appear as arguments in calls to
      the cornflower function: */
   
   Atimes2 = 2.0*A    ;   bTimes2 = 2.0*b ;
   Atimes3 = 3.0*A    ;   bTimes3 = 3.0*b ;

   /* Evaluate the answer: */

   ans = 7.0*sin(cornflower(A,b));
   ans = ans - 18.0*sqrt(15.0+abs(cornflower(Atimes2,bTimes2)));
   ans = ans + 34.0*log(41.0+abs(cornflower(Atimes3,bTimes3)));

   /* Return the answer: */

   return ans;
}

/************ End of yakMilk ************/
